#!/bin/sh
UNMAGX=/ezxlocal/unmagx
lookup () {
  while read addr type func stub
  do
    if [ -n "$stub" ]
    then
      break
    fi
    if [ "$type" = "T" ] && [ "$func" = "$1" ]
    then
      echo $addr
      return 0
    fi
  done < /proc/kallsyms
  false
}

HANGAR_HASH="f1f88bf11b4e6bc7fe7b4bc9bcab5da6a684b4d4"
MODULE_HASH_SYS_ENTRY="/sys/motmodule_hash/hash_list"
MODULE_HASH_MODULE="/lib/modules/module_sysfs.ko"
busybox insmod $MODULE_HASH_MODULE
OUTPUT=`sed 's/\([^ ]*\).*/\1/' /etc/modules.hash`
echo -e "$OUTPUT\n$HANGAR_HASH" > $MODULE_HASH_SYS_ENTRY
busybox rmmod $MODULE_HASH_MODULE

ADDR=$(lookup kallsyms_lookup_name) || exit 0

busybox insmod $UNMAGX/hangar18.ko kallsyms_lookup_addr=0x${ADDR}
busybox rmmod hangar18

# Remove noexec on good writeable places
mount -o remount,exec /ezxlocal
mount -o remount,exec none /dev/shm

# User-writeable flexbit
mount -o bind $UNMAGX/ezx_flexbit.cfg /usr/setup/ezx_flexbit.cfg

# Modem, Modem and Tools
mount -o bind $UNMAGX/connectionsetup /usr/SYSqtapp/systemsetup/connectionsetup

# Telnet
mount -t devpts devpts /dev/pts
busybox inetd /etc/inetd.engr
mount -o bind $UNMAGX/stub /etc/initservices/services/inetd.sh

# Ftp
$UNMAGX/bftpd -d -c $UNMAGX/bftpd.conf
mount -o bind $UNMAGX/passwd /etc/passwd
